"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// import capitalize from 'lodash.capitalize';
// import camelcase from 'lodash.camelcase';
const lodash_1 = require("lodash");
// Parses nvim api info and generates node client API names
function parseFunctionMetadata({ prefixMap, name }) {
    let typeName;
    let methodName;
    const matchedPrefix = Object.keys(prefixMap).find(prefix => name.indexOf(prefix) === 0);
    if (matchedPrefix) {
        typeName = prefixMap[matchedPrefix];
        methodName = lodash_1.camelCase(name.replace(matchedPrefix, ''));
    }
    else {
        // The type name is the word before the first dash capitalized. If the type
        // is Vim, then it a editor-global method which will be attached to the Nvim
        // class.
        const parts = name.split('_');
        typeName = lodash_1.capitalize(parts[0]);
        methodName = lodash_1.camelCase((typeName === 'Ui' ? parts : parts.slice(1)).join('_'));
    }
    return {
        typeName,
        methodName,
    };
}
exports.parseFunctionMetadata = parseFunctionMetadata;
